AbstractPDFExtensionElement (Apache FOP Core 2.11 API)
Date: 2025-04-24

org.apache.fop.render.pdf.extensions

## Class AbstractPDFExtensionElement

- java.lang.Object
- - org.apache.fop.fo.FONode
  - - org.apache.fop.render.pdf.extensions.AbstractPDFExtensionElement

- All Implemented Interfaces:
    Cloneable
  Direct Known Subclasses:
    PDFCollectionEntryElement, PDFEmbeddedFileElement

      public abstract class AbstractPDFExtensionElement
      extends FONode

  Base class for the PDF-specific extension elements.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.fop.fo.FONode

      `FONode.FONodeIterator, FONode.GatherContextInfoFunction`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected PDFExtensionAttachment` | `attachment` Extension attachment.

    - ### Fields inherited from class org.apache.fop.fo.FONode

      `FO_URI, FOX_URI, locator, log, nodeChangeBarList, parent, siblings, startOfNodeChangeBarList`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractPDFExtensionElement(FONode parent)` Default constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ExtensionAttachment` | `getExtensionAttachment()` Returns the extension attachment.
    `String` | `getNamespaceURI()` Returns the namespace URI for this node
    `String` | `getNormalNamespacePrefix()` Returns the normally used namespace prefix for this node
    `protected ExtensionAttachment` | `instantiateExtensionAttachment()` Instantiates extension attachment object.

    - ### Methods inherited from class org.apache.fop.fo.FONode

      `addCharacters, addChildNode, attachSiblings, bind, canHaveMarkers, characters, charIterator, clone, clone, collectDelimitedTextRanges, collectDelimitedTextRanges, createPropertyList, decorateWithContextInfo, endOfNode, errorText, finalizeNode, gatherContextInfo, getBuilderContext, getChangeBarList, getChildNodes, getChildNodes, getContentHandlerFactory, getContextInfo, getContextInfoAlt, getFOEventHandler, getFOValidationEventProducer, getLocalName, getLocator, getLocatorString, getLogger, getName, getName, getNameId, getNodePrefix, getNodeString, getParent, getRoot, getStructureTreeElement, getUserAgent, inMarker, invalidChildError, invalidChildError, invalidPropertyValueError, isBidiRangeBlockItem, isChangeBarElement, isDelimitedTextRangeBoundary, missingChildElementError, missingChildElementError, missingPropertyError, nodesOutOfOrderError, nodesOutOfOrderError, notSupportedChildError, processNode, removeChild, setLocator, setStructureTreeElement, startOfNode, tooManyNodesError, tooManyNodesError, tooManyNodesError, validateChildNode, validateChildNode, warningText`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### attachment

          protected PDFExtensionAttachment attachment

      Extension attachment.

  - ### Constructor Detail

    - #### AbstractPDFExtensionElement

          public AbstractPDFExtensionElement(FONode parent)

      Default constructor
      Parameters:
        `parent` - parent of this node
      See Also:
        `FONode.FONode(FONode)`

  - ### Method Detail

    - #### getNamespaceURI

          public String getNamespaceURI()

      Returns the namespace URI for this node
      Overrides:
        `getNamespaceURI` in class `FONode`
      Returns:
        the namespace URI for this node

    - #### getNormalNamespacePrefix

          public String getNormalNamespacePrefix()

      Returns the normally used namespace prefix for this node
      Specified by:
        `getNormalNamespacePrefix` in class `FONode`
      Returns:
        the normally used namespace prefix for this kind of node (ex. "fo" for XSL-FO)

    - #### getExtensionAttachment

          public ExtensionAttachment getExtensionAttachment()

      Returns the extension attachment.
      Overrides:
        `getExtensionAttachment` in class `FONode`
      Returns:
        the extension attachment if one is created by the extension element, null otherwise.
      See Also:
        `FONode.getExtensionAttachment()`

    - #### instantiateExtensionAttachment

          protected ExtensionAttachment instantiateExtensionAttachment()

      Instantiates extension attachment object.
      Returns:
        extension attachment

Copyright © 2025 Apache Software Foundation. All rights reserved.